import {Component, EventEmitter, Input, OnChanges, Output, SimpleChanges} from "ng-metadata/core";


/**
 * A component that lets the user set up a build trigger for a custom Git repository.
 */
@Component({
  selector: 'manage-trigger-custom-git',
  templateUrl: '/static/js/directives/ui/manage-trigger-custom-git/manage-trigger-custom-git.component.html'
})
export class ManageTriggerCustomGitComponent implements OnChanges {

  // FIXME: Use one-way data binding
  @Input('=') public trigger: {config: any};
  @Output() public activateTrigger: EventEmitter<{config: any, pull_robot?: any}> = new EventEmitter();
  private config: any = {"context": "/", "dockerfile_path": "/Dockerfile"};
  private currentState: any | null;

  public ngOnChanges(changes: SimpleChanges): void {
    if (changes['trigger'] !== undefined) {
      this.config = Object.assign({}, changes['trigger'].currentValue.config);
    }
    if (this.config.context === "") {
      this.config.context = "/";
    }

    if (this.config.dockerfile_path === "") {
      if (this.config.context.endsWith("/")) {
        this.config.dockerfile_path = this.config.context + "Dockerfile";
      } else {
        this.config.dockerfile_path = this.config.context + "/Dockerfile";
      }
    }
  }
}
